﻿using System;
using System.ComponentModel;
using System.Runtime.CompilerServices;

namespace GroupEditorPrototype
{
	public class ViewModelBase : INotifyPropertyChanged
	{
		public event PropertyChangedEventHandler PropertyChanged;

		protected void OnPropertyChanged(string propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

		protected void SetProperty<T>(ref T variable, T value, Action onChanged = null, [CallerMemberName] string propertyName = "")
		{
			variable = value;

			OnPropertyChanged(propertyName);
			onChanged?.Invoke();
		}
	}
}
